import pygame, math,random
from utility import*
from shotbase import StandardBullet
from vector import Vector
import particlebase, shipbase,enemy_ship

class Cruiser(shipbase.FlyingObject):
    def __init__(self,x,y, team,ship_type = enemy_ship.Fighter, spwn_range = 4000, max_area = 10, batch = 4, delay = 1.0):
        super(Cruiser, self).__init__(x, y, 2000, 2000, team)

        self.range = 1000

        self.health = 4000

        self.cr = 800

        self.range = spwn_range

        self.max = max_area

        self.spawnatonce = batch

        self.type = ship_type

        self.delay = 0
        self.delay_time = delay


        self.falling = False
        self.fall = 1.0

        self.frame = 0.0
        self.framerate = 20.0

        self.spawn_points = [
                            Vector([1,0])*(self.w*0.18),
                            Vector([-1,0])*(self.w*0.18),
                            Vector([0,1])*(self.w*0.18),
                            Vector([0,-1])*(self.w*0.18)]
                            
        
    def update(self, others, game, delta):

        self.delay -= delta

        self.frame += self.framerate*delta
        if self.frame >= 4:
            self.frame = 0
        
        if self.falling:
            self.fall -= 0.05*delta

        if self.fall <= 0.3:
            self.remove = True
            game.SpawnPart(particlebase.Explosion(self.x,self.y,700,2.0,-10))
            game.snd.play_sound("big explosion","major explosion")
            game.SpawnPart(particlebase.Flash(0.3))

        if not self.falling:
            cnt = 0
            for i in others:
                if id(i) != id(self) and i.team == self.team:
                    if Distance(self.x,self.y, i.x,i.y) < self.range:
                        cnt += 1

            if cnt < self.max:
                if self.delay < 0:
                    #how many to spawn
                    n = self.max-cnt
                    num = self.spawnatonce
                    if n <= self.spawnatonce:
                        num = n

                    for i in range(num):
                        v = random.choice(self.spawn_points)
                        d = v.normalised()

                        p = (v.rotated(random.randrange(-20/2,20/2))) + Vector([self.x,self.y])

                        game.ships.append(self.type(p.x,p.y,d.x,d.y,self.team))

                    
                        
            
                    
                
    def draw(self,engine,data):
        if not self.falling:
            engine.DrawImage(data.images["cruiser"], self.x,self.y,self.w,self.h,1,self.dir.angle,z = -0.1)        
        else:
            engine.DrawImage(data.images["cruiser dead"], self.x,self.y,self.w*self.fall,self.h*self.fall,1,self.dir.angle, z = (1.0-self.fall)*(-80))


    def get_hit(self, obj, game):
        if not self.falling:
            game.snd.play_sound("hit " + str(random.randrange(1,7)), "hit")
            self.health -= obj.damage
            if self.health <=0:
                self.falling = True
                game.SpawnPart(particlebase.Flash(0.3))
                game.snd.play_sound("big explosion", "major explosion")

    def check_bullets(self, bullets,game):
        if not self.falling:
            for b in bullets:
                if b.team != self.team:
                    if Distance(b.x,b.y,self.x,self.y) < self.cr/3:
                        self.get_hit(b,game)
                        b.on_hit(self,game)

                        d = Vector([self.x - b.x,self.y - b.y])
                        d = d.normalised()
                        game.SpawnPart(particlebase.BulletHit(b.x-d.x,b.y-d.x))
                        
                        if b.life <= 0:
                            bullets.remove(b)
