from worm2d import Engine, Viewport
import pygame, math
from utility import*
from vector import Vector

import game

class Title(object):
    def __init__(self,engine):
        self.view = Viewport(0,0,1,1, 100.0, 75.0)

        self.alpha_one = 0.0
        self.drop = -20.0*2
        self.alpha_two = 0.0
    def update(self,delta,engine):
        for event in pygame.event.get():
            if event.type == pygame.QUIT:
                return 1
            if event.type == pygame.MOUSEBUTTONDOWN:
                if event.button == 1:
                    return "main menu"

        self.alpha_one += 1.0*delta
        if self.alpha_one >= 1.0:
            self.alpha_one = 1.0

        if self.alpha_one == 1.0:
            self.drop += 75.0*delta
            if self.drop >= 0:
                self.drop = 0
        if self.drop == 0:
            self.alpha_two += 1.0*delta
            if self.alpha_two >= 1.0:
                self.alpha_two = 0.0
            
    def draw(self,data,engine):
        engine.PreRender(0.0, 0.0, 0.0)
        engine.SetView(self.view, 0,0,1)

        engine.DrawImage(data["title"],0,0,100,100,self.alpha_one,0)
        engine.DrawImage(data["title words"],0,self.drop,100,100,1,0)
        engine.DrawImage(data["title continue"],0,0,100,100,self.alpha_two,0)

        engine.PostRender()

class MainMenu(object):
    def __init__(self,engine):
        self.view = Viewport(0,0,1,1, 100.0, 75.0)
        self.dir = Vector([0,0])
        self.mx = 0
        self.my = 0
        self.selx = 0
        self.sely = 18.0

        self.selected = 0

        self.rot = 0

        self.options = [["icon start", "play", (0,-20,20)],
                        ["icon help", "help", (35.0/2,-20/2,10)],
                        ["icon quit", 1, (35,0,20)],
                        ["icon credits", "credits", (-35.0/2,-20/2,12)],
                        ["icon settings", "settings", (-35,0,25)]]
                        
    def update(self,delta,engine):
        for event in pygame.event.get():
            if event.type == pygame.QUIT:
                return 1
            if event.type == pygame.KEYDOWN:
                if event.key == pygame.K_ESCAPE:
                    return "title"
            if event.type == pygame.MOUSEBUTTONDOWN:
                if event.button == 1:
                    return self.options[self.selected][1]
        msx,msy = pygame.mouse.get_pos()
        self.mx,self.my = engine.MouseCoordsToWorldCoords(msx,msy,0,0,1, self.view)

        self.dir = Vector([self.selx-self.mx,self.sely-self.my])

        if self.dir.angle > 140:
            self.selected = 2
        elif self.dir.angle > 110:
            self.selected = 1
        elif self.dir.angle > 70:
            self.selected = 0
        elif self.dir.angle > 45:
            self.selected = 3
        elif self.dir.angle > -45:
            self.selected = 4

        self.rot += 90.0*delta
        
        
        #elif 
    def draw(self,data,engine):
        engine.PreRender(0.0, 0.0, 0.0)
        engine.SetView(self.view, 0,0,1)

        engine.DrawImage(data["selector"],self.selx,self.sely,50,50,1,self.dir.angle+90)

        for i in self.options:
            engine.DrawImage(data[i[0]],i[2][0],i[2][1],i[2][2],i[2][2],1,0)
            
        #engine.DrawImage(data["icon sel"],self.options[self.selected][2][0],self.options[self.selected][2][2][1],self.options[self.selected][2][2][2],self.options[self.selected][2][2][2],1,0)
        engine.DrawImage(data["icon sel"],self.options[self.selected][2][0],self.options[self.selected][2][1],self.options[self.selected][2][2]+5,self.options[self.selected][2][2]+5,1,self.rot)

        engine.PostRender()
    
class Settings(object):
    def __init__(self,engine):
        self.view = Viewport(0,0,1,1, 100.0, 75.0)
    def update(self,delta,engine):
        for event in pygame.event.get():
            if event.type == pygame.QUIT:
                return 1
            if event.type == pygame.MOUSEBUTTONDOWN:
                if event.button == 1:
                    return "main menu"
    def draw(self,data,engine):
        engine.PreRender(0.0, 0.0, 0.0)
        engine.SetView(self.view, 0,0,1)

        engine.DrawImage(data["settings page"],0,0,100,100,1,0)

        engine.PostRender()
    
class Help(object):
    def __init__(self,engine):
        self.view = Viewport(0,0,1,1, 100.0, 75.0)
    def update(self,delta,engine):
        for event in pygame.event.get():
            if event.type == pygame.QUIT:
                return 1
            if event.type == pygame.MOUSEBUTTONDOWN:
                if event.button == 1:
                    return "main menu"
    def draw(self,data,engine):
        engine.PreRender(0.0, 0.0, 0.0)
        engine.SetView(self.view, 0,0,1)

        engine.DrawImage(data["help page"],0,0,100,100,1,0)

        engine.PostRender()
    
class Credits(object):
    def __init__(self,engine):
        self.view = Viewport(0,0,1,1, 100.0, 75.0)
    def update(self,delta,engine):
        for event in pygame.event.get():
            if event.type == pygame.QUIT:
                return 1
            if event.type == pygame.MOUSEBUTTONDOWN:
                if event.button == 1:
                    return "main menu"
    def draw(self,data,engine):
        engine.PreRender(0.0, 0.0, 0.0)
        engine.SetView(self.view, 0,0,1)

        engine.DrawImage(data["credit page"],0,0,100,100,1,0)

        engine.PostRender()

class LevelSelect(object):
    def __init__(self,engine):
        self.view = Viewport(0,0,1,1, 100.0, 75.0)

        self.leveldata = []

        self.numunlocked = 5

        f = open("data/level/levelconfig.txt", "r")
        lines = f.readlines()
        for i in lines:
            if "#" in i:
                continue
            line = i.split(" ")
            if "LEVEL" in line:
                if line[1] == "locked":
                    continue
                d = [line[1], line[2], line[3].replace("+"," ").strip("\n").strip("\r")]
                self.leveldata.append(d)
        f.close()

        self.selected = 0

    def update(self,delta,engine):
        for event in pygame.event.get():
            if event.type == pygame.QUIT:
                return 1
            if event.type == pygame.KEYDOWN:
                if event.key == pygame.K_ESCAPE:
                    return "main menu"
            if event.type == pygame.MOUSEBUTTONDOWN:
                if event.button == 1:
                    return ["startlevel", self.leveldata[self.selected][1]]
        msx,msy = pygame.mouse.get_pos()
        mx,my = engine.MouseCoordsToWorldCoords(msx,msy,0,0,1, self.view)
        
        if my > 15:
            self.selected = 4
        elif my > 5:
            self.selected = 3
        elif my > -5:
            self.selected = 2
        elif my > -15:
            self.selected = 1
        else:
            self.selected = 0
            
    def draw(self,data,engine):
        engine.PreRender(0.0, 0.0, 0.0)
        engine.SetView(self.view, 0,0,1)

        engine.DrawImage(data["level page"],0,0,100,100,1,0)

        x,y = -30, -20
        for i in range(len(self.leveldata)):
            if self.leveldata[i][0] == "unlocked":
                engine.DrawImage(data[self.leveldata[i][2]],x,y,20,20,1,0)
                if self.selected == i:
                    engine.DrawImage(data["selector"],x-15,y,5,5,1,-90)
                y += 10

        engine.PostRender()

def MissionBriefing(engine,level,data):

    view = Viewport(0,0,1,1, 100.0, 75.0)

    sound_on = True
    aud_on = True
    
    f = open("data/config.txt", "r")
    lines = f.readlines()
    for i in lines:
        line = i.strip("\n").strip("\r").split(" ")
        if "AUDIO" in line:
            aud_on = ("on" in line)
        elif "SOUND" in line:
            sound_on = ("on" in line)
    f.close()
    

    sound = None
    if sound_on == True and aud_on == True:
        sound = pygame.mixer.Sound("data/menu/briefs/" + str(level) + ".wav")
        sound.play()

    while True:
        for event in pygame.event.get():
            if event.type == pygame.QUIT:
                return 1
            if event.type == pygame.KEYDOWN:
                if event.key == pygame.K_ESCAPE:
                    return 0
            if event.type == pygame.MOUSEBUTTONDOWN:
                if event.button == 1:
                    return 0
        engine.PreRender(0.0, 0.0, 0.0)
        engine.SetView(view, 0,0,1)

        engine.DrawImage(data["brief page"],0,0,100,100,1,0)
        engine.DrawImage(data["brief "+str(level)],0,0,100,100,1,0)

        engine.PostRender()

    


    
        
def LevelWin(engine,data):
    view = Viewport(0,0,1,1, 100.0, 75.0)
    while True:
        for event in pygame.event.get():
            if event.type == pygame.QUIT:
                return 1
            if event.type == pygame.KEYDOWN:
                if event.key == pygame.K_ESCAPE:
                    return 1
            if event.type == pygame.MOUSEBUTTONDOWN:
                if event.button == 1:
                    return 0
        engine.PreRender(0.0, 0.0, 0.0)
        engine.SetView(view, 0,0,1)

        engine.DrawImage(data["win page"],0,0,100,100,1,0)

        engine.PostRender()
    
def LevelLose(engine,data):
    view = Viewport(0,0,1,1, 100.0, 75.0)
    while True:
        for event in pygame.event.get():
            if event.type == pygame.QUIT:
                return 1
            if event.type == pygame.KEYDOWN:
                if event.key == pygame.K_ESCAPE:
                    return 1
            if event.type == pygame.MOUSEBUTTONDOWN:
                if event.button == 1:
                    return 0
        engine.PreRender(0.0, 0.0, 0.0)
        engine.SetView(view, 0,0,1)

        engine.DrawImage(data["lose page"],0,0,100,100,1,0)

        engine.PostRender()
def GameWin(engine,data):
    view = Viewport(0,0,1,1, 100.0, 75.0)
    while True:
        for event in pygame.event.get():
            if event.type == pygame.QUIT:
                return 1
            if event.type == pygame.KEYDOWN:
                if event.key == pygame.K_ESCAPE:
                    return 1
            if event.type == pygame.MOUSEBUTTONDOWN:
                if event.button == 1:
                    return 0
        engine.PreRender(0.0, 0.0, 0.0)
        engine.SetView(view, 0,0,1)

        engine.DrawImage(data["finish page"],0,0,100,100,1,0)

        engine.PostRender()

def SaveProgress(currentlevel):
    f = open("data/level/levelconfig.txt", "r")
    lines = f.readlines()
    data = []
    for i in lines:
        line = i.split(" ")
        data.append(line)
    f.close()

    cnt = 1
    for i in data:
        if i[0] == "LEVEL":
            cnt += 1
            if cnt <= currentlevel+1:
                i[1] = "unlocked"

    f = open("data/level/levelconfig.txt", "w")
    for i in data:
        string = ""
        for j in i:
           string = string + j
           if j != i[len(i)-1]:
               string = string + " "
        f.write(string)
    f.close()

    

class Levels(object):
    def __init__(self,level,engine,data,menudata):
        self.data = data
        self.menudata = menudata
        self.startlevel = "data/level/" + level
    def LevelNum(self):
        t = self.startlevel.strip("data/level/level").strip(".txt")
        num = int(t.strip("level"))
        return num
    def IncLevel(self):
        self.startlevel = self.startlevel.replace("4","5")
        self.startlevel = self.startlevel.replace("3","4")
        self.startlevel = self.startlevel.replace("2","3")
        self.startlevel = self.startlevel.replace("1","2")
    def update(self,delta,engine):
        run = True
        while run:
            MissionBriefing(engine,self.LevelNum(),self.menudata)
            pygame.mixer.music.stop()
            pygame.mixer.stop()
            g = game.Game(self.startlevel, engine,self.data)
            r = g.run()
            pygame.mixer.stop()
            pygame.mixer.music.stop()
            pygame.event.set_grab(False)
            pygame.mouse.set_visible(True)
            if r == -1:
                return "main menu"
            if r == 1:
                #win
                rt = LevelWin(engine,self.menudata)
                SaveProgress(self.LevelNum()+1)
                if rt == 1:
                    return 1
                if self.LevelNum() == 5:
                    GameWin(engine,self.menudata)
                    return "main menu"
                self.IncLevel()
            elif r == 0:
                rt = LevelLose(engine,self.menudata)
                if rt == 1:
                    return 1
    def draw(self,data,engine):
        pass


class Menu(object):
    def __init__(self,engine,data):
        self.engine = engine
        self.data = {}

        self.gamedata = data

        self.data["title"] = engine.LoadImage("data/menu/title.png")
        self.data["title words"] = engine.LoadImage("data/menu/titletitle.png")
        self.data["title continue"] = engine.LoadImage("data/menu/continue.png")

        self.data["icon start"] = engine.LoadImage("data/menu/start_icon.png")
        self.data["icon quit"] = engine.LoadImage("data/menu/quit_icon.png")
        self.data["icon settings"] = engine.LoadImage("data/menu/settings_icon.png")
        self.data["icon help"] = engine.LoadImage("data/menu/help_icon.png")
        self.data["icon credits"] = engine.LoadImage("data/menu/credits_icon.png")
        self.data["icon sel"] = engine.LoadImage("data/menu/circle.png")

        self.data["selector"] = engine.LoadImage("data/menu/goodguy.png")

        self.data["It Begins"] = engine.LoadImage("data/menu/l1.png")
        self.data["Fuel of War"] = engine.LoadImage("data/menu/l2.png")
        self.data["Ambushed!"] = engine.LoadImage("data/menu/l3.png")
        self.data["Strike Back"] = engine.LoadImage("data/menu/l4.png")
        self.data["The Final Battle"] = engine.LoadImage("data/menu/l5.png")

        self.data["credit page"] = engine.LoadImage("data/menu/credits.png")
        self.data["help page"] = engine.LoadImage("data/menu/help.png")
        self.data["settings page"] = engine.LoadImage("data/menu/settings.png")
        self.data["level page"] = engine.LoadImage("data/menu/levelselect.png")

        self.data["win page"] = engine.LoadImage("data/menu/complete.png")
        self.data["lose page"] = engine.LoadImage("data/menu/fail.png")
        self.data["brief page"] = engine.LoadImage("data/menu/settings.png")
        self.data["finish page"] = engine.LoadImage("data/menu/gamewin.png")

        self.data["brief page"] = engine.LoadImage("data/menu/brief.png")

        self.data["finish page"] = engine.LoadImage("data/menu/gamewin.png")

        self.data["brief 1"] = engine.LoadImage("data/menu/briefs/1.png")
        self.data["brief 2"] = engine.LoadImage("data/menu/briefs/2.png")
        self.data["brief 3"] = engine.LoadImage("data/menu/briefs/3.png")
        self.data["brief 4"] = engine.LoadImage("data/menu/briefs/4.png")
        self.data["brief 5"] = engine.LoadImage("data/menu/briefs/5.png")


        self.current = Title(self.engine)
    def run(self):
        run = True

        ticks = self.engine.GetTicks()

        while(run):
            delta = float(self.engine.GetTicks() - ticks)/1000.0
            ticks = self.engine.GetTicks()
            
            r = self.current.update(delta,self.engine)
            if r == 1:
                run = False
            else:
                if r == "main menu":
                    del self.current
                    self.current = MainMenu(self.engine)
                elif r == "title":
                    del self.current
                    self.current = Title(self.engine)
                elif r == "play":
                    del self.current
                    self.current = LevelSelect(self.engine)
                elif r == "settings":
                    del self.current
                    self.current = Settings(self.engine)
                elif r == "help":
                    del self.current
                    self.current = Help(self.engine)
                elif r == "credits":
                    del self.current
                    self.current = Credits(self.engine)
                elif type(r) == list:
                    print r
                    del self.current
                    self.current = Levels(r[1],self.engine,self.gamedata,self.data)
                
            self.current.draw(self.data,self.engine)               
        
