from worm2d import Engine, Viewport
import pygame, math,random
from utility import*
from vector import Vector

class Particle(object):
    def __init__(self, x,y,w,h,life):
        self.x = x
        self.y = y
        self.w = w
        self.h = h
        self.life = life
    def update(self,delta):
        pass
    def draw(self,engine,data):
        pass
    

class BulletHit(Particle):
    def __init__(self, x,y):
        super(BulletHit, self).__init__(x, y, 15, 15, 0.5)
    def update(self,delta):
        self.life -= delta
    def draw(self, engine, data):
        if self.life < 0.2:
            engine.DrawImage(data.images["h3"], self.x,self.y,self.w,self.h,self.life*2,0)
        elif self.life < 0.9:
            engine.DrawImage(data.images["h2"], self.x,self.y,self.w,self.h,self.life*2,0)
        else:
            engine.DrawImage(data.images["h1"], self.x,self.y,self.w,self.h,self.life*2,0)

class Explosion(Particle):
    def __init__(self,x,y,size,last, z = 0):
        super(Explosion, self).__init__(x, y, size, size, last)
        self.total = last
        self.z = z

    def update(self,delta):
        self.life -= delta

    def draw(self,engine,data):
        frame = 15 - int((self.life*15)/self.total)
        engine.DrawImage(data.images["exp1"][frame], self.x,self.y,self.w,self.h,min(1.0,self.life),0, z = self.z)


class Flash(Particle):
    def __init__(self,last):
        super(Flash, self).__init__(0, 0, 1, 1, last)

    def update(self,delta):
        self.life-=delta
    def draw(self,engine,data):
        engine.DrawQuad(engine.camx,engine.camy,engine.ratio_x*engine.zoom*2,engine.ratio_x*engine.zoom*2,1,1,1,1,1,z=10)

        
        
        
