from worm2d import Engine, Viewport
import pygame, math,random, vector
from utility import*


class FlyingObject(object):
    def __init__(self, x, y, w, h, team):

        self.team = team
        
        self.x = x
        self.y = y
        self.z = 0

        self.dx = 0
        self.dy = 1

        self.w = w
        self.h = h

        self.health = 100

        self.angle = dir_to_angle(self.dx,self.dy)
        
    def get_event(self,event):
        pass
    
    def update(self, others, game, delta):
        pass
    
    def draw(self,engine,data):
	engine.DrawQuad(self.x,self.y,self.w,self.h,1,0,0,0,self.angle)

class SmallFighterBase(FlyingObject):
    def __init__(self, x, y, w, h, team):
        super(SmallFighterBase, self).__init__(x, y, w, h, team)

        self.speed = 100.0

        self.turn_speed = 60

        self.target_range = 1000.0

        self.avoid_range = 50.0

        self.return_range = 300.0

        self.target = -1

        # ROAM, ATTACK, FOLLOW, AVOID
        self.state = "ROAM"

        self.rand_angle=0

    def update(self, others, game, delta):
        target = None
        
        if self.target == -1:
            t = FindNearest(self, others, self.target_range, [1])
            print t
            if t[0] != -1:
                self.target = t[0]
                self.state = "ATTACK"
                
        for i in others:
            if self.target == id(i):
                target = i

        if target != None:
            if self.state == "ATTACK":
                target_angle = dir_to_angle(self.x-target.x,self.y-target.y)%360

                d = TurnDir(self.angle, target_angle)

                self.angle += self.turn_speed*delta*d

                if Distance(self.x,self.y, target.x,target.y) < self.avoid_range:
                    self.state = "AVOID"
                    self.rand_angle = -(self.angle-180)
                    
            elif self.state == "AVOID":
                if Distance(self.x,self.y, target.x,target.y) > self.return_range:
                    self.state = "ATTACK"
                else:
                    target_angle = self.rand_angle
                    d = TurnDir(self.angle, target_angle)
                    self.angle += self.turn_speed*delta*d

        self.dx, self.dy = angle_to_dir(self.angle%360)

        self.x += self.dx*self.speed*delta
        self.y += self.dy*self.speed*delta


    def draw(self,engine,data):
        if self.team == 0:
            engine.DrawImage(data.images["goodguyship"], self.x,self.y,self.w,self.h,1,self.angle+90)
        if self.team == 1:
            engine.DrawImage(data.images["skyhawk"], self.x,self.y,self.w,self.h,1,self.angle+90)


class MouseShip(FlyingObject):
    def __init__(self, x, y, w, h, team):
        super(MouseShip, self).__init__(x, y, w, h, team)

    def update(self, others, game, delta):
        x,y = pygame.mouse.get_pos()
        self.x,self.y = game.engine.MouseCoordsToWorldCoords(x,y, game.cam[0], game.cam[1], game.cam[3], game.view)

    
    def draw(self,engine,data):
	engine.DrawQuad(self.x,self.y,self.w,self.h,1,0,0,0,self.angle)  

        
    
