from worm2d import Engine, Viewport
import pygame, math,random
from utility import*
from vector import Vector
import particlebase

class Bulletbase(object):
    def __init__(self, x,y,dx,dy,team, master_id, damage, speed):
        self.damage = damage
        self.x = x+dx
        self.y = y+dy
        self.lx = x
        self.ly = y
        self.w = 10
        self.h = 10
        self.dir = Vector([dx,dy])
        self.team = team
        self.mi = master_id
        self.speed = speed
        self.life = 1.0

    def update(self, delta):
        self.lx = self.x
        self.ly = self.y
        self.x += self.dir.x*self.speed*delta
        self.y += self.dir.y*self.speed*delta

        self.life -= delta
        
        pass

    def draw(self, engine, data):
        pass

    def on_hit(self, obj, game):
        self.life = -1

        

class StandardBullet(Bulletbase):
    def __init__(self, x,y,dx,dy,team, master_id, damage, speed,w=10,h=10):
        super(StandardBullet, self).__init__(x,y,dx,dy,team, master_id, damage, speed)
        self.w = w
        self.h = h

    def draw(self, engine, data):
        engine.DrawImage(data.images["shot"], self.x,self.y,self.w,self.h,1,self.dir.angle)
