import pygame, math


class SoundManager(object):
    def __init__(self, data):
        self.data = data.sounds, data.music
        self.audio_on = True
        self.sound_on = True
        self.music_on = True


        #load config
        f = open("data/config.txt", "r")
        lines = f.readlines()
        for i in lines:
            line = i.strip("\n").split(" ")
            if "AUDIO" in line:
                self.audio_on = ("on" in line)
            elif "SOUND" in line:
                self.sound_on = ("on" in line)
            elif "MUSIC" in line:
                self.music_on = ("on" in line)
        f.close()

        
        self.channels = {"hit" : pygame.mixer.Channel(1),
                         "shoot" : pygame.mixer.Channel(2),
                         "major explosion" : pygame.mixer.Channel(3),
                         "voice friend" : pygame.mixer.Channel(4),
                         "voice enemy" : pygame.mixer.Channel(5)}

    def play_sound(self,sound, chan = -1, loop=0):
        if self.audio_on and self.sound_on:
            if chan == -1:
                self.data[0][sound].play(loop)
            else:
                self.channels[chan].play(self.data[0][sound])

    def stop_sounds(self,chan = -1):
        if self.audio_on and self.sound_on:
            if chan == -1:
                pygame.mixer.stop()
            else:
                self.channels[chan].stop()

    def start_music(self,music):
        if self.audio_on and self.music_on:
            pygame.mixer.music.play(self.data[1][music])
        
    def stop_music(self,fade = -1):
        if self.audio_on and self.music_on:
            if fade == -1:
                pygame.mixer.music.stop()
            else:
                pygame.mixer.music.fadeout(fade)
            
        
