import math
from vector import Vector

def angle_to_dir(angle):
    ang = ((angle-90)*math.pi)/180
	
    dx = math.sin(ang)
    dy = -math.cos(ang)

    return dx,dy

def dir_to_angle(dx,dy):
    angle = math.atan2(dy, dx)
    if dx != 0 or dy != 0:
	angle = (angle * 180.0)/math.pi
    return angle

#first and others must have an x, y attributes
def FindNearest(first, others, maxrange, teams):
    cx, cy = -1, -1
    c = maxrange
    cid = -1
    cd = Vector([0,0])

    for i in others:
        if (i.team in teams) and (id(first) != id(i)):
            dist = math.sqrt( ((first.x-i.x) * (first.x-i.x)) + ((first.y-i.y) * (first.y-i.y)) )
            if dist < c:
                c = dist
                cid = id(i)
                cx, cy = i.x,i.y
                cd = i.dir

    return cid, c, cx,cy,cd

def Distance(x,y, x2,y2):
    return math.sqrt(((x-x2) * (x-x2)) + ((y-y2) * (y-y2)))

#def TurnDir(angle, target_angle):

#    d = 0

#    if target_angle>angle:
#        if target_angle-angle<180:  
#            d=1
#        else:
#            d=-1
#    else:
#        if angle-target_angle<180:   
#            d=-1  
#        else:   
#            d=1

#    return d

def TurnDir(angle, target_angle):
    d = 0
    if angle<=target_angle:
        d = 1
    if angle>target_angle:
        d = -1
    return d


def LineCircle(E,L,C,r):
    d = L - E
    f = E - C

    a = d.dot( d )
    b = 2*f.dot( d )
    c = f.dot( f ) - r*r

    if a == 0:
        return False
        

    discriminant = b*b-4*a*c
    if discriminant < 0:
        #no intersection
        return False
    else:
        discriminant = math.sqrt(discriminant)
        t1 = (-b + discriminant)/(2*a)
        t2 = (-b - discriminant)/(2*a)

        if t1 >= 0 and t1 <= 1:
            #solution is ON THE RAY
            return True
        else:
            return False

def CircleCircle(c1,r1,c2,r2):
    if Distance(c1.x,c1.y,c2.x,c2.y) < r1+r2:
        return True


def Side(forward, center, point):
    p = point - center

    l = Vector([1,0]).rotated(forward.angle)
    r = Vector([-1,0]).rotated(forward.angle)
    f = Vector([0,1]).rotated(forward.angle)
    b = Vector([0,-1]).rotated(forward.angle)

    flags = []
    #forward
    if l.dot(p) > 0 and r.dot(p) < 0:
        flags.append("f")
    #backward
    if l.dot(p) < 0 and r.dot(p) > 0:
        flags.append("b")
    #right
    if f.dot(p) < 0 and b.dot(p) > 0:
        flags.append("r")
    #left
    if f.dot(p) > 0 and b.dot(p) < 0:
        flags.append("l")
    return flags

    


    
